variables:
  FPM_IMAGE_NAME: rg.fr-par.scw.cloud/devops-in-net/sf-devops-in-net

stages:
  - test
  - build
  - dockerize
  - deploy

symfony_dependency_scanning:
  stage: test
  image: rg.fr-par.scw.cloud/devops-in-net/php:7.4.11-fpm-buster
  allow_failure: true
  script:
    - php -r "copy('https://get.sensiolabs.org/security-checker.phar', '/usr/local/bin/security-checker.phar');"
    - php /usr/local/bin/security-checker.phar security:chec composer.lock


test:
  variables:
    MYSQL_ROOT_PASSWORD: F8bU3h7kE
    MYSQL_DATABASE: test
    MYSQL_USER: gitlab-runner
    MYSQL_PASSWORD: 29exF7YgD
    DATABASE_URL: mysql://gitlab-runner:29exF7YgD@db:3306/test?serverVersion=5.7
    REDIS_HOST: redis"
    REDIS_PORT: "6379"
    REDIS_DATABASE: "2"

  stage: test
  image: rg.fr-par.scw.cloud/devops-in-net/php:7.4.11-fpm-buster

  script:
    - php -r "copy('https://raw.githubusercontent.com/vishnubob/wait-for-it/master/wait-for-it.sh', '/usr/local/bin/wait-for-it.sh');"
    - chmod +x /usr/local/bin/wait-for-it.sh
    - bash /usr/local/bin/wait-for-it.sh -h db -p 3306 -t 60
    - php -r "copy('https://getcomposer.org/installer', '/tmp/composer-setup.php');"
    - php /tmp/composer-setup.php
    - mv composer.phar /usr/local/bin/composer
    - chmod +x /usr/local/bin/composer
    - which composer
    - pwd
    - composer install --dev
    - php bin/console doctrine:schema:update -f
    - php bin/console doctrine:fixtures:load --purge-with-truncate -q
    - php bin/phpunit
  services:
    - name: mysql:5.7
      alias: db
    - name: redis:5-alpine
      alias: redis


compress:
  stage: build
  image: rg.fr-par.scw.cloud/devops-in-net/php:7.4.11-fpm-buster
  script:
    - php -r "copy('https://getcomposer.org/installer', '/tmp/composer-setup.php');"
    - php /tmp/composer-setup.php
    - mv composer.phar /usr/local/bin/composer
    - chmod +x /usr/local/bin/composer
    - composer install -a --prefer-dist
    - APP_ENV=prod php bin/console cache:clear
    - APP_ENV=prod php bin/console cache:warmup
    - tar -zcf ../project.tar.gz . && mv ../project.tar.gz .
  artifacts:
    paths:
      - project.tar.gz

.cdk8s:
  variables:
    TAG: $CI_COMMIT_BRANCH
    INGRESS_DOMAIN: $CI_COMMIT_REF_SLUG.kub.devops.in.net
    PRODUCTION_DOMAIN: www.devops.in.net
  stage: build
  image: node:stretch-slim
  tags:
    - cluster
    - kubernetes
  script:
      - cd kubernetes
      - npm install
      - npm run import
      - npm run compile
      - npm run synth
  artifacts:
    paths:
      - kubernetes/dist/

cdk8s-prod:
  extends: .cdk8s
  environment:
    url: https://www.devops.in.net
    name: production
  only:
    - master

cdk8s-dev:
  extends: .cdk8s
  environment:
    url: https://$CI_COMMIT_BRANCH.kub.devops.in.net
    name: dev/$CI_COMMIT_REF_SLUG
    on_stop: stop_dev
    auto_stop_in: 1 hour
  only:
    - branches
  except:
    - master

dockerize:
  stage: dockerize
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo $DOCKER_AUTH_CONFIG > /kaniko/.docker/config.json
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/docker/Dockerfile --destination $FPM_IMAGE_NAME:$CI_COMMIT_BRANCH
  tags:
    - cluster
    - kubernetes


.deploy:
  image: bitnami/kubectl
  stage: deploy
  script:
    - echo $DOCKER_AUTH_CONFIG > /tmp/config.json
    - kubectl apply -f kubernetes/dist/
    - kubectl delete secret scwregcred --ignore-not-found
    - kubectl create secret generic scwregcred --from-file=.dockerconfigjson=/tmp/config.json --type=kubernetes.io/dockerconfigjson
  tags:
    - cluster
    - kubernetes

deploy-prod:
  extends: .deploy
  environment:
    url: https://www.devops.in.net
    name: production
  when: manual
  only:
    - master

deploy-dev:
  extends: .deploy
  environment:
    url: https://$CI_COMMIT_BRANCH.kub.devops.in.net
    name: dev/$CI_COMMIT_REF_SLUG
    on_stop: stop_dev
    auto_stop_in: 1 hour
  only:
    - branches
  except:
    - master


stop_dev:
  image: bitnami/kubectl
  variables:
    GIT_STRATEGY: none
  stage: deploy
  script:
    - kubectl delete all,ingress,pvc --all
  when: manual
  environment:
    name: dev/$CI_COMMIT_REF_SLUG
    action: stop
  only:
    - branches
  except:
    - master
  tags:
    - cluster
    - kubernetes
